/* HTTP Proxy Server, by Mark Kamichoff [kamicm@rpi.edu] *
 * File for signal handling functions                    */

void signalpipe(void)
{
        fprintf(stderr, "Debug: Caught a SIGPIPE, transfer interrupted\n");
}

void sig_chld(void)             // Only called if we are in LINUX
{
        pid_t pid;
        int stat;

        while((pid = waitpid(-1, &stat, WNOHANG)) > 0);

        return;
}

void signalinterrupt(void)
{
        printf("Cleaning up and exiting gracefully...\n");
        close(listeningfd);
        close(clientfd);
        sleep(1);
        exit(0);
}

void setupsignals(void)
{
#ifndef LINUX                           // We ignore SIGCHLD in Solaris
        signal(SIGCHLD,SIG_IGN);
#endif
#ifdef LINUX                            // We handle SIGCHLD in Linux
        signal(SIGCHLD,(void *) sig_chld);
#endif
        signal(SIGPIPE,(void *) signalpipe);
        signal(SIGINT,(void *) signalinterrupt);
        signal(SIGTERM,(void *) signalinterrupt);
}

